#ifndef BALANCEWINDOW_H
#define BALANCEWINDOW_H

/*
	Balance plugin for SoundPlay.
	(C) 2000, Tim Vernum <tpv@users.sourceforge.net>
	May be used freely in any SoundPlay plugin
*/

#include "MWindow.h"

class MSlider ;

namespace SoundPlay
{
	namespace Plugins
	{
		namespace Balance
		{
			//////////////////////////////////////////////////
			////////////// Balance Window ////////////////////
			//////////////////////////////////////////////////

			class BalanceWindow : public MWindow
			{
				typedef MWindow inherited ;

				public:
					BalanceWindow();
					virtual ~BalanceWindow();
			
					virtual bool QuitRequested();
			
					status_t GetBalance( float& left, float& right ) ;
					status_t SetBalance( float left, float right ) ;
					
					int32 SliderCount( void ) ;
					void  SetSliderCount( int32 ) ;
					
				private:
					MSlider * CreateSlider( const char *, int, int  );
					void SetupChildren( int32 count ) ;
					
					MSlider * slider1 ;
					MSlider * slider2 ;
					bool keepalive;
			
			};
		
		}
	}
}

#endif

