#include "Config.h"

/*
	Balance plugin for SoundPlay.
	(C) 2000, Tim Vernum <tpv@users.sourceforge.net>
	May be used freely in any SoundPlay plugin
*/

#ifndef   BALANCEWINDOW_H
#include "BalanceWindow.h"
#endif

#include <Message.h>
#include <Autolock.h>

#include <stdio.h>

namespace SoundPlay
{
	namespace Plugins
	{
		namespace Balance
		{
			void SetConfig(void *data, BMessage *config)
			{
				BalanceWindow * win = reinterpret_cast<BalanceWindow *>( data ) ;
				BAutolock lock( win ) ;
			
				BRect frame;
				if( B_OK == config->FindRect("frame",&frame) )
				{
					win->MoveTo( frame.LeftTop() ) ;
					win->ResizeTo( frame.Width() , frame.Height() ) ;
				}
			
				int32 count ;
				if( B_OK == config->FindInt32( "slider-count", &count ) )
				{
					win->SetSliderCount( count ) ;
				}

				float l,r ;
				if( B_OK == config->FindFloat( "left-balance", &l )
				 && B_OK == config->FindFloat( "right-balance", &r ) )
				{
printf( "SetConfig: ( %f , %f )\n", l,r ) ;
					win->SetBalance( l,r ) ;
				}
				
			}
		
			void GetConfig(void *data, BMessage *config)
			{
				BalanceWindow * win = reinterpret_cast<BalanceWindow *>( data ) ;
				BAutolock lock( win ) ;
			
				config->MakeEmpty();
			
				config->AddRect("frame", win->Frame() );
			
				float l,r ;
				win->GetBalance( l,r ) ;
printf( "GetConfig: ( %f , %f )\n", l,r ) ;
				config->AddFloat( "left-balance", l );
				config->AddFloat( "right-balance", r );
				
				config->AddInt32( "slider-count", win->SliderCount() ) ;
			}
		}
	}
}
