#ifndef   FILTER_H
#include "Filter.h"
#endif

/*
	Balance plugin for SoundPlay.
	(C) 2000, Tim Vernum <tpv@users.sourceforge.net>
	May be used freely in any SoundPlay plugin
*/

#ifndef   BALANCEWINDOW_H
#include "BalanceWindow.h"
#endif

#ifndef   CONSTRAIN_H
#include "constrain.h"
#endif

#include <Autolock.h>

namespace SoundPlay
{
	namespace Plugins
	{
		namespace Balance
		{

			status_t DoFilter( void * data , short * buffer , int32 framecount , void * /* ignore */ )
			{
				BalanceWindow * win = reinterpret_cast<BalanceWindow *>( data ) ;
				
				float mLeft , mRight ;
				status_t status ;
				
				{ // lock
					BAutolock alock( win ) ;
					status = win->GetBalance( mLeft , mRight ) ;
				} // unlock
							
				if( status != B_OK )
					return status ;

				for( int i=0 ; i < framecount ; i++ )
				{
					short * left  = (buffer++) ;
					short * right = (buffer++) ;
					float l = (mLeft * (*left) ) ;
					float r = (mRight * (*right) ) ;
			
					constrain<float,-32768,32768>(l) ;
					constrain<float,-32768,32768>(r) ;
					
					*left  = static_cast<short>(l) ;
					*right = static_cast<short>(r) ;
				}
				return status ;
			}

		}
	}
}