#include "XBitmap.h"

/*
	Balance plugin for SoundPlay.
	(C) 2000, Tim Vernum <tpv@users.sourceforge.net>
	May be used freely in any SoundPlay plugin
*/

#include <Bitmap.h>
#include <Point.h>

namespace Extensions
{
	namespace Bitmap
	{
		uint8 * GetBitsAt( BBitmap * bitmap, BPoint& pos )
		{
			switch( bitmap->ColorSpace() )
	        {
				case B_RGB32:
				{
					void * bits = bitmap->Bits() ;
					uint8 * row = reinterpret_cast<uint8 *>(bits) + (static_cast<int32>(pos.y) * bitmap->BytesPerRow()) ;
					uint8 * byte = row + (static_cast<int32>(pos.x) * 4) ; // 32 bits == 4 bytes
					return byte ;
				}
				default:
				{
					return NULL ;
				}
			}
		}
		
		rgb_color GetColourAt( BBitmap * bitmap, BPoint& pos )
		{
			uint8 * bits = GetBitsAt(bitmap, pos) ;
			rgb_color rgb = { 0,0,0,0 } ;
			if( !bits )
				return rgb ;
			
			switch( bitmap->ColorSpace() )
	        {
				case B_RGB32:
				{
					rgb.red   = bits[2] ;
					rgb.green = bits[1] ;
					rgb.blue  = bits[0] ;
					rgb.alpha = bits[3] ;
					return rgb ;
				}
				default:
				{
					return rgb ;
				}
			}
		}

		void SetColourAt( BBitmap * bitmap, BPoint& pos , rgb_color& rgb )
		{
			uint8 * bits = GetBitsAt(bitmap,pos) ;
			if( !bits )
				return ;
			
			switch( bitmap->ColorSpace() )
	        {
				case B_RGB32:
				{
					bits[0] = rgb.blue ;
					bits[1] = rgb.green ;
					bits[2] = rgb.red ;
					bits[3] = rgb.alpha ;
					return ;
				}
				default:
				{
					return ;
				}
			}
		}
	}
}
