#ifndef CONSTRAIN_H
#define CONSTRAIN_H

/*
	Balance plugin for SoundPlay.
	(C) 2000, Tim Vernum <tpv@users.sourceforge.net>
	May be used freely in any SoundPlay plugin
*/

/**
 * Constrain a value of type T to be within the range LOW - HIGH.
 * If f < LOW then set f to LOW
 * If f > HIGH then set f to HIGH
 * @param f value to constrain - modified in place
 * @return f
 */
template <typename T, long LOW, long HIGH>
inline T constrain( T & f )
{
	if(f < LOW)
		f = LOW ;
	else if(f > HIGH)
		f = HIGH ;
	
	return f ;
}

#endif

